com.jnape.palatable.lambda.functions.builtin.fn3

## Class CmpEqBy<A,B extends Comparable<B>>

- java.lang.Object
- - com.jnape.palatable.lambda.functions.builtin.fn3.CmpEqBy<A,B>

- Type Parameters:
    `A` - the value type
    `B` - the mapped comparison type
  All Implemented Interfaces:
    Fn1<Fn1<? super A,? extends B>,Fn1<A,Fn1<A,Boolean>>>, Fn2<Fn1<? super A,? extends B>,A,Fn1<A,Boolean>>, Fn3<Fn1<? super A,? extends B>,A,A,Boolean>, Applicative<Fn1<A,Fn1<A,Boolean>>,Fn1<Fn1<? super A,? extends B>,?>>, Cartesian<Fn1<? super A,? extends B>,Fn1<A,Fn1<A,Boolean>>,Fn1<?,?>>, Cocartesian<Fn1<? super A,? extends B>,Fn1<A,Fn1<A,Boolean>>,Fn1<?,?>>, Contravariant<Fn1<? super A,? extends B>,Profunctor<?,Fn1<A,Fn1<A,Boolean>>,Fn1<?,?>>>, Functor<Fn1<A,Fn1<A,Boolean>>,Fn1<Fn1<? super A,? extends B>,?>>, Profunctor<Fn1<? super A,? extends B>,Fn1<A,Fn1<A,Boolean>>,Fn1<?,?>>, Monad<Fn1<A,Fn1<A,Boolean>>,Fn1<Fn1<? super A,? extends B>,?>>, MonadReader<Fn1<? super A,? extends B>,Fn1<A,Fn1<A,Boolean>>,Fn1<Fn1<? super A,? extends B>,?>>, MonadRec<Fn1<A,Fn1<A,Boolean>>,Fn1<Fn1<? super A,? extends B>,?>>, MonadWriter<Fn1<? super A,? extends B>,Fn1<A,Fn1<A,Boolean>>,Fn1<Fn1<? super A,? extends B>,?>>

      public final class CmpEqBy<A,B extends Comparable<B>>
      extends Object
      implements Fn3<Fn1<? super A,? extends B>,A,A,Boolean>

  Given a mapping function from some type `A` to some `Comparable` type `B` and two values of type `A`, return `true` if the first value is strictly equal to the second value (according to `Comparable.compareTo(Object)` in terms of their mapped `B` results; otherwise, return false.
  See Also:
    `CmpEq`, `LTBy`, `GTBy`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `BiPredicate<A,A>` | `apply(Fn1<? super A,? extends B> compareFn)` Partially apply this function by taking its first argument.
    `Predicate<A>` | `apply(Fn1<? super A,? extends B> compareFn, A x)` Partially apply this function by taking its first two arguments.
    `Boolean` | `checkedApply(Fn1<? super A,? extends B> compareFn, A x, A y)`
    `static <A,B extends Comparable<B>> CmpEqBy<A,B>` | `cmpEqBy()`
    `static <A,B extends Comparable<B>> BiPredicate<A,A>` | `cmpEqBy(Fn1<? super A,? extends B> compareFn)`
    `static <A,B extends Comparable<B>> Predicate<A>` | `cmpEqBy(Fn1<? super A,? extends B> compareFn, A x)`
    `static <A,B extends Comparable<B>> Boolean` | `cmpEqBy(Fn1<? super A,? extends B> compareFn, A x, A y)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `apply, checkedApply, compose, contraMap, diMapL, discardR, flip, fn3, fn3, fn3, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `checkedApply, curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public Boolean checkedApply(Fn1<? super A,? extends B> compareFn,
                                      A x,
                                      A y)

      Specified by:
        `checkedApply` in interface `Fn3<Fn1<? super A,? extends B extends Comparable<B>>,A,A,Boolean>`

    - #### apply

          public BiPredicate<A,A> apply(Fn1<? super A,? extends B> compareFn)

      Description copied from interface: `Fn3`
      Partially apply this function by taking its first argument.
      Specified by:
        `apply` in interface `Fn1<Fn1<? super A,? extends B extends Comparable<B>>,Fn1<A,Fn1<A,Boolean>>>`
      Specified by:
        `apply` in interface `Fn2<Fn1<? super A,? extends B extends Comparable<B>>,A,Fn1<A,Boolean>>`
      Specified by:
        `apply` in interface `Fn3<Fn1<? super A,? extends B extends Comparable<B>>,A,A,Boolean>`
      Parameters:
        `compareFn` - the first argument
      Returns:
        an `Fn2`<B, C, D>

    - #### apply

          public Predicate<A> apply(Fn1<? super A,? extends B> compareFn,
                                    A x)

      Description copied from interface: `Fn3`
      Partially apply this function by taking its first two arguments.
      Specified by:
        `apply` in interface `Fn2<Fn1<? super A,? extends B extends Comparable<B>>,A,Fn1<A,Boolean>>`
      Specified by:
        `apply` in interface `Fn3<Fn1<? super A,? extends B extends Comparable<B>>,A,A,Boolean>`
      Parameters:
        `compareFn` - the first argument
        `x` - the second argument
      Returns:
        an `Fn1`<C, D>

    - #### cmpEqBy

          public static <A,B extends Comparable<B>> CmpEqBy<A,B> cmpEqBy()

    - #### cmpEqBy

          public static <A,B extends Comparable<B>> BiPredicate<A,A> cmpEqBy(Fn1<? super A,? extends B> compareFn)

    - #### cmpEqBy

          public static <A,B extends Comparable<B>> Predicate<A> cmpEqBy(Fn1<? super A,? extends B> compareFn,
                                                                         A x)

    - #### cmpEqBy

          public static <A,B extends Comparable<B>> Boolean cmpEqBy(Fn1<? super A,? extends B> compareFn,
                                                                    A x,
                                                                    A y)